//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%37F0C8E32CB0.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%37F0C8E32CB0.cm

//## begin module%37F0C8E32CB0.cp preserve=no
//## end module%37F0C8E32CB0.cp

//## Module: AddComponent%37F0C8E32CB0; Package body
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/AddComponent.cxx

//## begin module%37F0C8E32CB0.additionalIncludes preserve=no
//## end module%37F0C8E32CB0.additionalIncludes

//## begin module%37F0C8E32CB0.includes preserve=yes
//## end module%37F0C8E32CB0.includes

// ComponentBase
#include <XSModel/Model/Component/ComponentBase.h>
// typeinfo
#include <typeinfo>
// AddComponent
#include <XSModel/Model/Component/AddComponent.h>
//## begin module%37F0C8E32CB0.declarations preserve=no
//## end module%37F0C8E32CB0.declarations

//## begin module%37F0C8E32CB0.additionalDeclarations preserve=yes
#include <XSUtil/FunctionUtils/XSModelFunction.h>
#include <XSModel/Model/UniqueEnergy.h>
#include <XSModel/Model/Component/SumComponent.h>
#include "XSstreams.h"
//## end module%37F0C8E32CB0.additionalDeclarations


// Class AddComponent 

AddComponent::AddComponent(const AddComponent &right)
  //## begin AddComponent::AddComponent%362809470320_copy.hasinit preserve=yes
      :Component(right), m_normParNum(right.m_normParNum)
  //## end AddComponent::AddComponent%362809470320_copy.hasinit
  //## begin AddComponent::AddComponent%362809470320_copy.initialization preserve=yes
  //## end AddComponent::AddComponent%362809470320_copy.initialization
{
  //## begin AddComponent::AddComponent%362809470320_copy.body preserve=yes
  cloneParameters(*this,right);
  //## end AddComponent::AddComponent%362809470320_copy.body
}

AddComponent::AddComponent (CGroupBase* p)
  //## begin AddComponent::AddComponent%37EF952529B0.hasinit preserve=yes
      : Component(p), m_normParNum(0)
  //## end AddComponent::AddComponent%37EF952529B0.hasinit
  //## begin AddComponent::AddComponent%37EF952529B0.initialization preserve=yes
  //## end AddComponent::AddComponent%37EF952529B0.initialization
{
  //## begin AddComponent::AddComponent%37EF952529B0.body preserve=yes
  //## end AddComponent::AddComponent%37EF952529B0.body
}


AddComponent::~AddComponent()
{
  //## begin AddComponent::~AddComponent%362809470320_dest.body preserve=yes
  componentBase()->deleteParameters();
  //## end AddComponent::~AddComponent%362809470320_dest.body
}



//## Other Operations (implementation)
int AddComponent::read ()
{
  //## begin AddComponent::read%374D98C9B76F.body preserve=yes
  int status = Component::read();
  // the argument is unnecessary, but clarifies here.
  addParam("norm");        
  m_normParNum = componentBase()->numParams() - 1;
  return status;  
  //## end AddComponent::read%374D98C9B76F.body
}

AddComponent* AddComponent::clone (CGroupBase* p) const
{
  //## begin AddComponent::clone%38E3B8D44118.body preserve=yes
  AddComponent* cloned = new AddComponent(*this);
  cloned->setParent(p);
  return cloned;  
  //## end AddComponent::clone%38E3B8D44118.body
}

Real AddComponent::norm () const
{
  //## begin AddComponent::norm%3AD4AA4F00B1.body preserve=yes
  return parameterSet(m_normParNum)->value();
  //## end AddComponent::norm%3AD4AA4F00B1.body
}

void AddComponent::copy (const Component& right)
{
  //## begin AddComponent::copy%3A953DDA02D9.body preserve=yes
  if ( typeid(*this) != typeid(right) ) 
          throw RedAlert("*** Programmer Error: copying to wrong type ***");  
  AddComponent __temp(static_cast<const AddComponent&>(right));
  swap(__temp);   
  //## end AddComponent::copy%3A953DDA02D9.body
}

void AddComponent::swap (Component& right)
{
  //## begin AddComponent::swap%3A953DE30013.body preserve=yes
  Component::swap(right);
  AddComponent& that = static_cast<AddComponent&>(right);
  std::swap(m_normParNum,that.m_normParNum);  
  //## end AddComponent::swap%3A953DE30013.body
}

void AddComponent::calculate (bool saveComponentFlux, bool frozen)
{
  //## begin AddComponent::calculate%3ADB03ED02AF.body preserve=yes
  
  typedef std::set<UniqueEnergy*> UniqueEnergyContainer;
  if (saveComponentFlux) saveUniquePhotonArray(saveComponentFlux);
                  
  const std::vector<Parameter *>& parameterSet = componentBase()->parameterSet();
  size_t  numParams = parameterSet.size();
  RealArray  startValues(numParams);
  
  bool proceed = true;
  if (frozen)
  {
        // if the 'frozen' flag is set, only compute this component if
        // the normalization is either frozen or linked only to frozen.
        size_t j = 0;
        Parameter* normalization = 0;
        while ( j < numParams )
        {
                if (parameterSet[j]->name() == "norm")
                {
                        normalization = parameterSet[j];
                        break;
                }  
                ++j;
               
        }
        if (!normalization->isFrozen() && !Parameter::isLinkedToFrozen(normalization)) 
                        proceed = false;
  }
    
  if (proceed)
  {
     const UniqueEnergyContainer& energies = getUniqueEnergies();
     for (size_t  i=0; i<numParams; i++)
     {
        startValues[i] = parameterSet[i]->value();
     }
     UniqueEnergyContainer::const_iterator en   = energies.begin();
     UniqueEnergyContainer::const_iterator enEnd = energies.end();

     while (en != enEnd)
     {
        // Passing a spectrumNumber to generator only makes sense
        // if component was flagged to enforce one UniqueEnergy
        // obj for each spectrum.  Otherwise we'll assume the
        // model function will just ignore it.
        const UniqueEnergy* uniqueEng = *en;
        size_t spectrumNumber = *uniqueEng->clientSpectra().begin();
        RealArray& fluxArray = uniquePhotonArray(uniqueEng);
        RealArray& fluxErrArray = uniquePhotonErrArray(uniqueEng);
        const XSModelFunction*  generator(componentBase()->generator());
        (*generator)(uniqueEng->energy(), startValues, spectrumNumber, fluxArray,
                        fluxErrArray,componentBase()->initString());

        // fluxErrArray is initialized to zero in generator
        // and then resized to zero if it wasn't used.
        fluxErrArray.size() > 0  ? error(true) : error(false);

        // output arrays if in debug mode (harmlessly returns if log chatter
        // is < 30)
        debugPrint(tcout,"\nModel Output AddComponent::calculate() -");
        ++en;
      }
  }  
  else
  {
          const UniqueEnergyContainer& energies = getUniqueEnergies();
          UniqueEnergyContainer::const_iterator en   = energies.begin();
          UniqueEnergyContainer::const_iterator enEnd = energies.end();
          while (en != enEnd)
          {
                uniquePhotonArray(*en).resize(0);
                uniquePhotonErrArray(*en).resize(0);
                ++en;
          }
  }
  //## end AddComponent::calculate%3ADB03ED02AF.body
}

// Additional Declarations
  //## begin AddComponent%362809470320.declarations preserve=yes
  //## end AddComponent%362809470320.declarations

//## begin module%37F0C8E32CB0.epilog preserve=yes
//## end module%37F0C8E32CB0.epilog
